NX Open C++ Reference Guide
|
This class represents a offset surface builder, used for creating or editing an offset surface feature. More...
Public Types | |
enum | OrientationMethodType { OrientationMethodTypeUseExistingNormals, OrientationMethodTypeSpecifyInteriorPosition } |
Represents the type of orientation method. More... | |
enum | OutputOptionType { OutputOptionTypeOneFeatureForConnectedFaces, OutputOptionTypeOneFeatureForEachFace, OutputOptionTypeOneFeatureForAllFaces } |
Represents the type of output option. More... | |
Public Member Functions | |
void | AddFaceSets (const std::vector< NXOpen::GeometricUtilities::FaceSetOffset * > &faceSets) |
Adds face sets to the face set list. | |
bool | ApproxOption () |
Returns the option to create approximate offset surface if the offset surface has self-intersections. | |
void | DeleteFaceSet (int index) |
Deletes a face set at the specified index from the face set list. | |
NXOpen::GeometricUtilities::FaceSetOffsetList * | FaceSets () |
Returns the list of face sets. | |
NXOpen::GeometricUtilities::FaceSetOffset * | FindFaceSet (int index) |
Finds and returns a face set at the specified index from the face set list. | |
NXOpen::ObjectList * | GetFaceSetList () |
Gets the list of face sets. | |
std::vector < NXOpen::GeometricUtilities::FaceSetOffset * > | GetFaceSets () |
Gets the face sets. | |
NXOpen::Point3d | GetInteriorPosition () |
Gets the offset surface interior position for specify interior position method. | |
NXOpen::Features::OffsetSurfaceBuilder::OrientationMethodType | GetOrientationMethod () |
Returns the offset surface orientation method based on the Features::OffsetSurfaceBuilder::OutputOptionType. | |
int | MaximumExcludedObjects () |
Returns the maximum excluded objects during partial offset. | |
NXOpen::Features::OffsetSurfaceBuilder::OutputOptionType | OutputOption () |
Returns the offset surface output option based on the enum Features::OffsetSurfaceBuilder::OutputOptionType. | |
bool | PartialOption () |
Returns the option to pursue a partial offset result. | |
NXOpen::Expression * | Radius () |
Returns the radius for error vertex excision during partial offset. | |
bool | RemoveProblemVerticesOption () |
Returns the option to remove problem vertices. | |
void | SetApproxOption (bool approxOption) |
Sets the option to create approximate offset surface if the offset surface has self-intersections. | |
void | SetInteriorPosition (const NXOpen::Point3d &point) |
Sets the offset surface interior position for specify interior position method. | |
void | SetMaximumExcludedObjects (int maximumExcludedObjects) |
Sets the maximum excluded objects during partial offset. | |
void | SetOrientationMethod (NXOpen::Features::OffsetSurfaceBuilder::OrientationMethodType orientationMethod) |
Sets the orientation method Created in NX4.0.0. | |
void | SetOutputOption (NXOpen::Features::OffsetSurfaceBuilder::OutputOptionType outputOption) |
Sets the offset surface output option based on the enum Features::OffsetSurfaceBuilder::OutputOptionType. | |
void | SetPartialOption (bool partialOption) |
Sets the option to pursue a partial offset result. | |
void | SetRemoveProblemVerticesOption (bool removeProblemVerticesOption) |
Sets the option to remove problem vertices. | |
void | SetStepOption (bool stepOption) |
Sets the offset surface allow step boundaries option. | |
void | SetTolerance (double tolerance) |
Sets the offset surface tolerance. | |
bool | StepOption () |
Returns the offset surface allow step boundaries option. | |
double | Tolerance () |
Returns the offset surface tolerance. | |
![]() | |
NXOpen::Features::Feature * | CommitFeature () |
Commits the feature parameters and creates the feature. | |
NXOpen::Features::Feature * | GetFeature () |
Returns the feature currently being edited by this builder. | |
void | HideInternalParentFeatureAfterEdit (NXOpen::Features::Feature *parentFeature) |
Re-suppress an internal parent feature (a slave feature) after it has been edited. | |
bool | ParentFeatureInternal () |
Returns whether or not the latest timestamped parent feature of this feature should be made internal Created in NX5.0.0. | |
bool | PatchSolutionFlag () |
Returns the patch solution flag Created in NX8.0.1. | |
NXString | PatchSurfaceFilename () |
Returns the patch surface filename Created in NX8.0.1. | |
void | SetParentFeatureInternal (NXOpen::Features::Feature *parentFeature) |
Set the parent features which would be internal or slaves to the feature being created or commited Created in NX6.0.0. | |
void | SetParentFeatureInternal (bool isInternal) |
Sets whether or not the latest timestamped parent feature of this feature should be made internal Created in NX5.0.0. | |
void | SetPatchSolutionFlag (bool optionValue) |
Sets the patch solution flag Created in NX8.0.1. | |
void | SetPatchSurfaceFilename (const NXString &surfaceFilename) |
Sets the patch surface filename Created in NX8.0.1. | |
void | SetPatchSurfaceFilename (const char *surfaceFilename) |
Sets the patch surface filename Created in NX8.0.1. | |
void | SetSurroundingPatchSurfaceFilename (const NXString &surroundingSurfaceFilename) |
Sets the surrounding patch surface filename Created in NX8.0.1. | |
void | SetSurroundingPatchSurfaceFilename (const char *surroundingSurfaceFilename) |
Sets the surrounding patch surface filename Created in NX8.0.1. | |
void | ShowInternalParentFeatureForEdit (NXOpen::Features::Feature *parentFeature) |
Unsuppress an internal parent feature (a slave feature) so it can be edited. | |
NXString | SurroundingPatchSurfaceFilename () |
Returns the surrounding patch surface filename Created in NX8.0.1. | |
void | UnsetParentFeatureInternal (NXOpen::Features::Feature *parentFeature) |
Set the internal parent feature of the feature being edited to external Created in NX6.0.0. | |
![]() | |
NXOpen::NXObject * | Commit () |
Commits any edits that have been applied to the builder. | |
void | Destroy () |
Deletes the builder, and cleans up any objects created by the builder. | |
std::vector< NXOpen::NXObject * > | GetCommittedObjects () |
For builders that create more than one object, this method returns the objects that are created by commit. | |
NXOpen::NXObject * | GetObject () |
Returns the object currently being edited by this builder. | |
void | ShowResults () |
Updates the model to reflect the result of an edit to the model for all builders that support showing results. | |
virtual bool | Validate () |
Validate whether the inputs to the component are sufficient for commit to be called. | |
![]() | |
tag_t | GetTag () const |
<b>Deprecated</b>:<br> Use Tag instead. | |
tag_t | Tag () const |
Returns the tag of this object. | |
This class represents a offset surface builder, used for creating or editing an offset surface feature.
The offset surface feature allows different face sets to be offset by different distances.
To create a new instance of this class, use Features::FeatureCollection::CreateOffsetSurfaceBuilder
Default values.
Property | Value |
---|---|
ApproxOption |
False |
OutputOption |
OneFeatureForConnectedFaces |
PartialOption |
False |
StepOption |
True |
Created in NX4.0.0.
Represents the type of orientation method.
This is applicable only if the output output is Features::OffsetSurfaceBuilder::OutputOptionTypeOneFeatureForEachFace . The first enum value implies that the offset direction will be that of the surface normal whereas the second enum value implies that am interior position will be specified and the offset direction will be away from this point
Represents the type of output option.
The faces to be offset can be disconnected and also from multiple bodies. If either is the case, then multiple features are created. For deciding whether there should be one feature for each topologically connected set of faces or one feature for each face selected the enum below has been provided
void NXOpen::Features::OffsetSurfaceBuilder::AddFaceSets | ( | const std::vector< NXOpen::GeometricUtilities::FaceSetOffset * > & | faceSets | ) |
Adds face sets to the face set list.
Created in NX4.0.0.
License requirements : solid_modeling ("SOLIDS MODELING")
faceSets | Face set list |
bool NXOpen::Features::OffsetSurfaceBuilder::ApproxOption | ( | ) |
Returns the option to create approximate offset surface if the offset surface has self-intersections.
Created in NX4.0.0.
License requirements : None
void NXOpen::Features::OffsetSurfaceBuilder::DeleteFaceSet | ( | int | index | ) |
Deletes a face set at the specified index from the face set list.
Created in NX4.0.0.
License requirements : solid_modeling ("SOLIDS MODELING")
index | Index of face set to be deleted |
NXOpen::GeometricUtilities::FaceSetOffsetList* NXOpen::Features::OffsetSurfaceBuilder::FaceSets | ( | ) |
Returns the list of face sets.
Each element defines a set of faces, and an offset distance applied to those faces.
Created in NX4.0.0.
License requirements : None
NXOpen::GeometricUtilities::FaceSetOffset* NXOpen::Features::OffsetSurfaceBuilder::FindFaceSet | ( | int | index | ) |
Finds and returns a face set at the specified index from the face set list.
@return Face set returned
Created in NX4.0.0.
License requirements : solid_modeling ("SOLIDS MODELING")
index | Index of face set to be returned |
NXOpen::ObjectList* NXOpen::Features::OffsetSurfaceBuilder::GetFaceSetList | ( | ) |
Gets the list of face sets.
This list is a simple variable length array of any JA object.
Created in NX4.0.0.
License requirements : None
std::vector<NXOpen::GeometricUtilities::FaceSetOffset *> NXOpen::Features::OffsetSurfaceBuilder::GetFaceSets | ( | ) |
Gets the face sets.
A face set is a combination of a face collector and an offset distance.
Created in NX4.0.0.
License requirements : None
NXOpen::Point3d NXOpen::Features::OffsetSurfaceBuilder::GetInteriorPosition | ( | ) |
Gets the offset surface interior position for specify interior position method.
@return Interior position for specify interior position method
Created in NX4.0.0.
License requirements : None
NXOpen::Features::OffsetSurfaceBuilder::OrientationMethodType NXOpen::Features::OffsetSurfaceBuilder::GetOrientationMethod | ( | ) |
Returns the offset surface orientation method based on the Features::OffsetSurfaceBuilder::OutputOptionType.
@return Orientation method
Created in NX4.0.0.
License requirements : None
int NXOpen::Features::OffsetSurfaceBuilder::MaximumExcludedObjects | ( | ) |
Returns the maximum excluded objects during partial offset.
If the excluded objects reach this number, the partial offset will stop.
Created in NX7.5.0.
License requirements : None
NXOpen::Features::OffsetSurfaceBuilder::OutputOptionType NXOpen::Features::OffsetSurfaceBuilder::OutputOption | ( | ) |
Returns the offset surface output option based on the enum Features::OffsetSurfaceBuilder::OutputOptionType.
Created in NX4.0.0.
License requirements : None
bool NXOpen::Features::OffsetSurfaceBuilder::PartialOption | ( | ) |
Returns the option to pursue a partial offset result.
Created in NX7.5.0.
License requirements : None
NXOpen::Expression* NXOpen::Features::OffsetSurfaceBuilder::Radius | ( | ) |
Returns the radius for error vertex excision during partial offset.
Created in NX7.5.0.
License requirements : None
bool NXOpen::Features::OffsetSurfaceBuilder::RemoveProblemVerticesOption | ( | ) |
Returns the option to remove problem vertices.
Created in NX7.5.0.
License requirements : None
void NXOpen::Features::OffsetSurfaceBuilder::SetApproxOption | ( | bool | approxOption | ) |
Sets the option to create approximate offset surface if the offset surface has self-intersections.
Created in NX4.0.0.
License requirements : solid_modeling ("SOLIDS MODELING")
approxOption | Approximate offset option |
void NXOpen::Features::OffsetSurfaceBuilder::SetInteriorPosition | ( | const NXOpen::Point3d & | point | ) |
Sets the offset surface interior position for specify interior position method.
This allows the specified faces to be offset away from the interior position.
Created in NX4.0.0.
License requirements : solid_modeling ("SOLIDS MODELING")
point | Interior position for specify interior position method |
void NXOpen::Features::OffsetSurfaceBuilder::SetMaximumExcludedObjects | ( | int | maximumExcludedObjects | ) |
Sets the maximum excluded objects during partial offset.
If the excluded objects reach this number, the partial offset will stop.
Created in NX7.5.0.
License requirements : solid_modeling ("SOLIDS MODELING")
maximumExcludedObjects | Maximum excluded objects |
void NXOpen::Features::OffsetSurfaceBuilder::SetOrientationMethod | ( | NXOpen::Features::OffsetSurfaceBuilder::OrientationMethodType | orientationMethod | ) |
Sets the orientation method
Created in NX4.0.0.
License requirements : solid_modeling ("SOLIDS MODELING")
orientationMethod | Orientation method |
void NXOpen::Features::OffsetSurfaceBuilder::SetOutputOption | ( | NXOpen::Features::OffsetSurfaceBuilder::OutputOptionType | outputOption | ) |
Sets the offset surface output option based on the enum Features::OffsetSurfaceBuilder::OutputOptionType.
Created in NX4.0.0.
License requirements : solid_modeling ("SOLIDS MODELING")
outputOption | Output option |
void NXOpen::Features::OffsetSurfaceBuilder::SetPartialOption | ( | bool | partialOption | ) |
Sets the option to pursue a partial offset result.
Created in NX7.5.0.
License requirements : solid_modeling ("SOLIDS MODELING")
partialOption | partialoption |
void NXOpen::Features::OffsetSurfaceBuilder::SetRemoveProblemVerticesOption | ( | bool | removeProblemVerticesOption | ) |
Sets the option to remove problem vertices.
Created in NX7.5.0.
License requirements : solid_modeling ("SOLIDS MODELING")
removeProblemVerticesOption | removeproblemverticesoption |
void NXOpen::Features::OffsetSurfaceBuilder::SetStepOption | ( | bool | stepOption | ) |
Sets the offset surface allow step boundaries option.
If this option is true then side faces will be created along any smooth edge between a face which is offset and one which is not.
Created in NX4.0.0.
License requirements : solid_modeling ("SOLIDS MODELING")
stepOption | Allow step boundaries option |
void NXOpen::Features::OffsetSurfaceBuilder::SetTolerance | ( | double | tolerance | ) |
Sets the offset surface tolerance.
Created in NX4.0.0.
License requirements : solid_modeling ("SOLIDS MODELING")
tolerance | Tolerance |
bool NXOpen::Features::OffsetSurfaceBuilder::StepOption | ( | ) |
Returns the offset surface allow step boundaries option.
If this option is true then side faces will be created along any smooth edge between a face which is offset and one which is not.
Created in NX4.0.0.
License requirements : None
double NXOpen::Features::OffsetSurfaceBuilder::Tolerance | ( | ) |
Returns the offset surface tolerance.
Created in NX4.0.0.
License requirements : None